/*

     NONO 
     Copyright (C) 2002 Remco Schellekens
   
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the license, or 
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/


#pragma pack( 2 )

/* Pilot header files. */

#include <PalmOS.h>
#include <PalmCompatibility.h>

/* Local header files. */

#include "nono.h"


struct brdInfo {
	short nmTop[10][4];
	short nmBot[4][10];
	short flPlaced[10][10];
	short flSolution[10][10];
	short flChecked;
	short flPressed;
	int game;
};

short updateX,updateY;


/* Prototype local functions. */

void DrawForm( void );
void DrawPlayArea( void );
void RefreshPlayArea( void );
void InitGame( int );
int  CheckBrd ( void );
void YouWin( void );
void NewGame( int );
void SolveIt( void );
void SaveGameState( void );

/* Global variables. */

static FormPtr frm;

static struct brdInfo brd;


    
DWord PilotMain( Word cmd, Ptr cmdPBP, Word launchFlags )
{
    if ( cmd == sysAppLaunchCmdNormalLaunch )
    {
        short err,gx,gy;
        short x,y,dumflag;
		short type;
        EventType e;
        int iExit = 0;

        FrmGotoForm( ID_Frmnono );

        InitGame( 0 );

        while ( !iExit )
        {
            EvtGetEvent( &e, -1 );

            if ( SysHandleEvent( &e ) )
            {
                continue;
            }

            if ( MenuHandleEvent( ( void * ) 0, &e, &err ) )
            {
                continue;
            }

            switch ( e.eType )
            {
                case frmLoadEvent :
                    
                    frm = FrmInitForm( e.data.frmLoad.formID );
                    FrmSetActiveForm( frm );
                    
                    
                    break;
                    
                case frmOpenEvent :
                    
                    DrawForm();
                    break;
                    
                case penMoveEvent :
					/* grid */
                   	if ((e.screenX>50)&&(e.screenX<140)&&(e.screenY>40)&&
						(e.screenY<130)) {
						gx=((e.screenX-50)/9);
						gy=((e.screenY-40)/9);
						if ((gx==updateX)&&(gy==updateY)) break;
					} else {
						updateX=664;
						updateY=664;
						break;
					}

                case penDownEvent :
					type=0;

					/* checkbox */
                   	if ((e.screenX>4)&&(e.screenX<16)&&(e.screenY>141)&&
						(e.screenY<153)) type=1;

                   	if ((e.screenY>14)&&(e.screenY<22)) {

						/* Game decrease */
						if ((e.screenX>3)&&(e.screenX<12))
							type=3;
						else

						/* Game increase */
							if ((e.screenX>30)&&(e.screenX<39)) type=4;
					}

					/* grid */
                   	if ((e.screenX>50)&&(e.screenX<140)&&(e.screenY>40)&&
						(e.screenY<130)) type=5;



					switch(type) {
						case 1: /* checkbox */
							updateX=665;
							updateY=665;
							brd.flChecked=(brd.flChecked)?0:1;
							if (brd.flChecked==0) {
								dumflag=0;
								for (x=0;((x<10)&&(!dumflag));x++) {
									for (y=0;((y<10)&&(!dumflag));y++) {
										if (brd.flPlaced[x][y]>2)
											dumflag=1;
									}
								}
								if (dumflag) {
									switch (FrmAlert(ID_AltTry)) {
										/* clear */
										case 0:
											for (x=0;x<10;x++) {
												for (y=0;y<10;y++) {
													if (brd.flPlaced[x][y]>2)
														brd.flPlaced[x][y]=0;
												}
											}
											updateX=666;
											updateY=666;
											break;
										/* mark */
										case 1:
											for (x=0;x<10;x++) {
												for (y=0;y<10;y++) {
													if (brd.flPlaced[x][y]>2)
														brd.flPlaced[x][y]-=2;
												}
											}
											updateX=666;
											updateY=666;
											break;

										/* keep */
										default:
											break;
									}
								}
								DrawPlayArea();
								if (CheckBrd()) {
									updateX=666;
									updateY=666;
									YouWin();
								} 
							} else {
								RefreshPlayArea();
							}
							break;

						case 3: /* Game decrease */
							updateX=666;
							updateY=666;
							if ( brd.game>1) 
								brd.game--;
							else 
								brd.game=222;
							SaveGameState();
							InitGame(2);
							DrawPlayArea();
							break;

						case 4: /* Game increase */
							updateX=666;
							updateY=666;
							if ( brd.game<222) 
								brd.game++;
							else 
								brd.game=1;
							SaveGameState();
							InitGame(2);
							DrawPlayArea();
							break;

						case 5: /* block */
							gx=((e.screenX-50)/9);
							gy=((e.screenY-40)/9);
							switch (brd.flPlaced[gx][gy]) {
								case 0:
									if (brd.flChecked)
										brd.flPlaced[gx][gy]=3;
									else
										brd.flPlaced[gx][gy]=1;
									break;
								case 1:
								case 3:
									brd.flPlaced[gx][gy]++;
									break;
								case 2:
								case 4:
									brd.flPlaced[gx][gy]=0;
									break;
							}
							updateX=gx;
							updateY=gy;
							RefreshPlayArea();
							break;

						default:
							updateX=666;
							updateY=666;
							FrmHandleEvent( FrmGetActiveForm(), &e );
							break;
					}
						
                    break;
                    
				case penUpEvent :
					/* up-event from pen down in grid */
					if ((updateX<665)) {
						if (CheckBrd()) {
							updateX=666;
							updateY=666;
							YouWin();
						} 
					}
                    break;
                    
                case menuEvent :
					updateX=666;
					updateY=666;
                    
                    switch ( e.data.menu.itemID )
                    {
                        case ID_MnuItmNew :
                            NewGame( 1 );
                            break;

                        case ID_MnuItmSolve:
							SolveIt();
							break;
                            
                        case ID_MnuItmAbout :
                            FrmAlert( ID_AltAbout );
							DrawPlayArea();
                            break;

                        case ID_MnuItmHow:
                            if (FrmAlert( ID_AltHow))
								if (FrmAlert( ID_AltHow2))
									if (FrmAlert( ID_AltHow3))
										FrmAlert( ID_AltHow4);
							DrawPlayArea();
                            break;
                    }
                    
                    break;
                    
                case ctlSelectEvent :
                    
                    NewGame( 1 );
                    break;
                    
                case appStopEvent:
                    
                    FrmCloseAllForms();
                    iExit = 1;
                    break;
                    
                default:
                    
                    FrmHandleEvent( FrmGetActiveForm(), &e );
                    break;
            }
        }
        
        SaveGameState();
    }
    
    return( 0 );
}

/*
 */

void DrawForm( void )
{
    FrmDrawForm( FrmGetActiveForm() );
    DrawPlayArea();
}

/*
 */

void DrawPlayArea( void ) {
	int x,y;
	int i=0;
	RectangleType r;
	char dum[2];
#ifndef USE_BW
	WinSetTextColor(0);
#endif
	r.topLeft.x = 0;
	r.topLeft.y = 0;
	r.extent.x = 160;
	r.extent.y = 160;

	dum[1]='\0';
#ifndef USE_BW
	WinSetBackColor(86);
#endif
	WinEraseRectangle(&r,0);

	/*  numbers on top */
	for (x=0;x<10;x++) {
		for (y=0;y<4;y++) {
			if (brd.nmTop[x][y]>0)  {
				dum[0]='0'+brd.nmTop[x][y];
				WinDrawChars(&dum[0],1,x*9+53,y*9+2);
			}
		}
	}

	/* numbers on the left */
	for (x=0;x<4;x++) {
		for (y=0;y<10;y++) {
			if (brd.nmBot[x][y]>0)  {
				dum[0]='0'+brd.nmBot[x][y];
				WinDrawChars(&dum[0],1,x*9+15,y*9+39);
			}
		}
	}

	/* grid */

#ifndef USE_BW
	WinSetForeColor(215);
	for (x=0;x<=90;x+=9) {
		WinDrawLine(51+x,41  ,51+x,131 );
		WinDrawLine(51  ,41+x,141 ,41+x);
		WinDrawLine(52+x,42  ,52+x,132 );
		WinDrawLine(52  ,42+x,142 ,42+x);

	}
	WinSetForeColor(0);
#endif
	for (x=0;x<=90;x+=9) {
		WinDrawLine(50+x,40  ,50+x,130 );
		WinDrawLine(50  ,40+x,140 ,40+x);
	}

	/* CheckBox */

#ifndef USE_BW
	WinSetForeColor(255);
#endif
	r.topLeft.x = 5;
	r.topLeft.y = 142;
	r.extent.x = 10;
	r.extent.y = 10;
	WinDrawRectangle(&r,0);

#ifndef USE_BW
	WinSetForeColor(0);
#endif
	r.topLeft.x = 6;
	r.topLeft.y = 143;
	r.extent.x = 8;
	r.extent.y = 8;

#ifndef USE_BW
	WinDrawRectangle(&r,0);
#else
	WinEraseRectangle(&r,0);
#endif
	WinDrawChars("Try mode",8,20,142);


	/* Game */

#ifndef USE_BW
	WinSetForeColor(0);
#endif
	WinDrawLine(5 ,18,10,20);
	WinDrawLine(5 ,18,10,16);
	WinDrawLine(10,20,10,16);

	WinDrawLine(37,18,32,20);
	WinDrawLine(37,18,32,16);
	WinDrawLine(32,20,32,16);


	updateX=666;
	updateY=666;
    RefreshPlayArea();
	CheckBrd();
}


void RefreshPlayArea( void ) {
	short x,y;
	RectangleType r;
	Char game[]="   ";
#ifdef USE_BW
	short tp=0;
	short cnt=0;
#endif

	/* Game */

	if (!((updateX>=0)&&(updateX<10))) {
#ifndef USE_BW
		WinSetTextColor(0);
		WinSetBackColor(86);
#endif
		FntSetFont(boldFont);
		WinDrawChars("Number",6,4,3);
		if ((brd.game>=100)>=1) game[0]='0'+(brd.game/100);
		if ((brd.game>=10)>=1) game[1]='0'+((brd.game/10)%10);
		if ((brd.game)>=1) game[2]='0'+brd.game%10;
		WinDrawChars(game,3,13,13);
		FntSetFont(stdFont);
	}
	
	/* checkbox */

	if (!((updateX>=0)&&(updateX<10))) {
		if (brd.flChecked) {
#ifndef USE_BW
			WinSetForeColor(137);
#endif
			WinDrawLine(7 ,144,11,149);
			WinDrawLine(8 ,144,12,149);
			WinDrawLine(11,147,17,140);
			WinDrawLine(11,149,17,140);
			WinDrawLine(12,149,17,140);
		} else { 
#ifndef USE_BW
			WinSetForeColor(86);
#endif
			r.topLeft.x = 11;
			r.topLeft.y = 139;
			r.extent.x = 7;
			r.extent.y = 6;
#ifndef USE_BW
			WinDrawRectangle(&r,0);
#else
			WinEraseRectangle(&r,0);
#endif
#ifndef USE_BW
			WinSetForeColor(255);
#endif
			r.topLeft.x = 5;
			r.topLeft.y = 142;
			r.extent.x = 10;
			r.extent.y = 10;
			WinDrawRectangle(&r,0);
#ifndef USE_BW
			WinSetForeColor(0);
#endif
			r.topLeft.x = 6;
			r.topLeft.y = 143;
			r.extent.x = 8;
			r.extent.y = 8;
#ifndef USE_BW
			WinDrawRectangle(&r,0);
#else
			WinEraseRectangle(&r,0);
#endif
		}
	}


	/* Blocks */

	for (x=0;x<10;x++) {
		for (y=0;y<10;y++) {
			if ((updateX!=666)&&(updateY!=666)&&((updateX!=x)||updateY!=y)) continue;
#ifndef USE_BW
			if ((brd.flPlaced[x][y]%2)==0) {
				WinSetForeColor(255);
				r.topLeft.x = x*9+52;
				r.topLeft.y = y*9+42;
				r.extent.x = 7;
				r.extent.y = 7;
				WinDrawRectangle(&r,1);
				WinSetForeColor(86);
#else
				r.topLeft.x = x*9+51;
				r.topLeft.y = y*9+41;
				r.extent.x = 8;
				r.extent.y = 8;
				WinEraseRectangle(&r,1);
#endif
				r.topLeft.x = x*9+53;
				r.topLeft.y = y*9+43;
				r.extent.x = 6;
				r.extent.y = 6;
#ifndef USE_BW
				WinDrawRectangle(&r,1);
			}
#endif
			switch (brd.flPlaced[x][y]) {
				case 1 :
				case 2 :  
#ifndef USE_BW
					WinSetForeColor(108); /* placed        */
#else 
					tp=1;
#endif
					break; 
				case 3 :
				case 4 :  
#ifndef USE_BW
					WinSetForeColor(110);  /* test          */
#else 
					tp=2;
#endif
					break;
				default:  
#ifndef USE_BW
					WinSetForeColor(86); /* nothing       */
#else 
					tp=3;
#endif
					break;
			}
			switch (brd.flPlaced[x][y]) {
				case 2 :
				case 4 :                              /* non-placed    */
					r.topLeft.x = x*9+54;
					r.topLeft.y = y*9+44;
					r.extent.x = 3;
					r.extent.y = 3;
					break;

				case 1 :
				case 3 :                              /* placed        */
#ifndef USE_BW
					r.topLeft.x = x*9+52;
					r.topLeft.y = y*9+42;
					r.extent.x = 7;
					r.extent.y = 7;
#else
					r.topLeft.x = x*9+51;
					r.topLeft.y = y*9+41;
					r.extent.x = 8;
					r.extent.y = 8;
#endif
					break;

				default:                               /* nothing      */
#ifndef USE_BW
					r.topLeft.x = x*9+53;
					r.topLeft.y = y*9+43;
					r.extent.x = 6;
					r.extent.y = 6;
#else
					r.topLeft.x = x*9+51;
					r.topLeft.y = y*9+41;
					r.extent.x = 8;
					r.extent.y = 8;
#endif
					break;
			}
#ifndef USE_BW
			WinDrawRectangle(&r,1);
#else
			switch (tp) {
				case 1:
					WinDrawRectangle(&r,1);
					break;
				case 2:
					for (cnt=r.topLeft.x;cnt<r.topLeft.x+r.extent.x;cnt++) {
						WinDrawGrayLine(cnt,r.topLeft.y,cnt,
							r.topLeft.y+r.extent.y-1);
					}
					break;
				case 3:
					WinEraseRectangle(&r,1);	
					break;
			}
#endif
		}
	}
}

int CheckBrd() {
	short x,y;
	short ln[8];
	char dum[2];
	short c;
	short faulty;
	short wrong=0;

	dum[1]='\0';
	for (x=0;x<10;x++) {
		for (y=0;y<8;ln[y++]=0);
		c=0;
		for (y=0;y<10;y++) {
			if (y>0) {
				if ((brd.flPlaced[x][y-1]!=1)&&(brd.flPlaced[x][y]==1)) {
					if (ln[c]) c++;
				}
			}
			if (brd.flPlaced[x][y]==1) {
				ln[c]++;	
			}
		}
		for (y=0;y<4;y++) {
			if (ln[3]==0) {
				ln[3]=ln[2];
				ln[2]=ln[1];
				ln[1]=ln[0];
				ln[0]=0;
			} else {
				y=4;
			}
		}
		faulty=0;
		if (c>3) {
			faulty=1;
			wrong=1;
		}
		for (y=0;y<4;y++) {
			if (ln[y]!=brd.nmTop[x][y]) {
				wrong=1;
				faulty=1;
			}
		}
		if (!(faulty)) 
#ifdef USE_BW
			FntSetFont(boldFont);
#else
			WinSetTextColor(255);
#endif
		for (y=0;y<4;y++) {
			if (brd.nmTop[x][y]>0)  {
				dum[0]='0'+brd.nmTop[x][y];
				WinDrawChars(&dum[0],1,x*9+53,y*9+2);
			}
		}
#ifdef USE_BW
		FntSetFont(stdFont);
#else
		WinSetTextColor(0);
#endif

	}
	for (y=0;y<10;y++) {
		for (x=0;x<8;ln[x++]=0);
		c=0;
		for (x=0;x<10;x++) {
			if (x>0) {
				if ((brd.flPlaced[x-1][y]!=1)&&(brd.flPlaced[x][y]==1)) {
					if (ln[c]) c++;
				}
			}
			if (brd.flPlaced[x][y]==1) {
				ln[c]++;	
			}
		}
		for (x=0;x<4;x++) {
			if (ln[3]==0) {
				ln[3]=ln[2];
				ln[2]=ln[1];
				ln[1]=ln[0];
				ln[0]=0;
			} else {
				x=4;
			}
		}
		faulty=0;
		if (c>3) {
			faulty=1;
			wrong=1;
		}
		for (x=0;x<4;x++) {
			if (ln[x]!=brd.nmBot[x][y]) {
				wrong=1;
				faulty=1;
			}
		}
		if (!(faulty)) 
#ifdef USE_BW
			FntSetFont(boldFont);
#else
			WinSetTextColor(255);
#endif
		for (x=0;x<4;x++) {
			if (brd.nmBot[x][y]>0) {
				dum[0]='0'+brd.nmBot[x][y];
				WinDrawChars(&dum[0],1,x*9+15,y*9+39);
			}
		}
#ifdef USE_BW
		FntSetFont(stdFont);
#else
		WinSetTextColor(0);
#endif
	}
	if (wrong) 
		return 0;
	else 
		return 1;
}

/*
 */


/*
 */

void InitGame( int iNew )
{
	short x,y,cx,cy;
	short ch=0;
	short rx[10],ry[10];
	short gotpref=0;

	updateX=666;
	updateY=666;
    if ( PrefGetAppPreferencesV10( (ULong) 'NONO', 1, (VoidPtr) &brd,
                                            sizeof( brd) ) ) gotpref=1;

	if (iNew==1) {
		for (x=0;x<10;x++) {
			for (y=0;y<10;y++) {
				brd.flPlaced[x][y]=0;
			}
		}
	} else {
		if ((!gotpref)||(iNew>1)) {
			if ((!gotpref)&&(iNew<1)) brd.game=1;
			brd.flChecked=0;
			brd.flPressed=0;

			/* clear all stuff ...*/
			for (x=0;x<10;x++) {
				for (y=0;y<10;y++) {
					brd.flPlaced[x][y]=0;
					brd.flSolution[x][y]=0;
				}
			}

			/* first, find a solution                          */
			/* misuse game id for seed                         */
			/* chance of 1 on 2 that a square will be filled   */

			SysRandom(brd.game);
			for (x=0;x<10;x++) {
				rx[x]=0;
				ry[x]=0;
			}

			for (x=0;x<10;x++) {
				for (y=0;y<10;y++) {
					if (SysRandom(0)%2)	 {
							brd.flSolution[x][y]=0;
						} else {
							cx=0;
							if (x>0) {
								if (brd.flSolution[x-1][y]!=1) {
									cy=1;
									ry[y]++;
								}
							}
						cy=0;
						if (y>0) {
							if (brd.flSolution[x][y-1]!=1) {
								cx=1;
								rx[x]++;

							}
						}
						if ((rx[x]>3)||(ry[y]>3)) {
							brd.flSolution[x][y]=0;
							rx[x]-=cx;
							ry[y]-=cy;
						} else {
							brd.flSolution[x][y]=1;
						}
					}
				}
			}
			/* ok, now get the numbers */
			for (x=0;x<10;x++) {
				for (y=0;y<4;y++) {
					brd.nmTop[x][y]=0;
					brd.nmBot[y][x]=0;
				}
			}
			for (x=0;x<10;x++) {
				rx[x]=3;
				ry[x]=3;
			}
			for (x=9;x>=0;x--) {
				for (y=9;y>=0;y--) {
					if (x<9) {
						if ((brd.flSolution[x+1][y]==1)&&
							(brd.flSolution[x  ][y]==0)) {
							rx[y]--;	
						}
					}
					if (y<9) {
						if ((brd.flSolution[x][y+1]==1)&&
							(brd.flSolution[x][y  ]==0)) {
							ry[x]--;	
						}
					}
					if (brd.flSolution[x][y]) {
						brd.nmTop[x][ry[x]]++;
						brd.nmBot[rx[y]][y]++;
					}
				}
			}



			
		}
	}
}

/*
 */


void YouWin( void )
{
    FrmAlert( ID_AltWin);
	if (brd.game<222)
		brd.game++;
	else
		brd.game=1;
	SaveGameState();
	InitGame(2);
	DrawPlayArea();
}

/*
 */

void NewGame( int iAsk )
{
    if ( ( iAsk ? FrmAlert( ID_AltClear) == 0 : 1 ) )
    {
        InitGame( 2 );
    }
    DrawPlayArea();
}

void SolveIt( )
{
	short x,y;
    if ( FrmAlert( ID_AltSolve) == 0 ) {
		for (x=0;x<10;x++) {
			for (y=0;y<10;y++) {
				brd.flPlaced[x][y]=brd.flSolution[x][y];
				if (!(brd.flPlaced[x][y])) {
					brd.flPlaced[x][y]=2;
				}
			}
		}
    }
    DrawPlayArea();
}


/*
 */


void SaveGameState( void ) {
    PrefSetAppPreferencesV10( 'NONO', 1, &brd, sizeof( brd) );
}
